package com.vitria.bw;

import java.util.HashMap;
import java.util.Map;

import javax.ejb.Remote;
import javax.ejb.Stateless;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;

@Stateless (name="NetBankBean") 
@Remote ({NetBank.class})
public class NetBankBean implements NetBank {
	Map<String, Double> bank_ = new HashMap<String, Double>();
	
	@Override
	public double query(String acct) {
		System.out.println("****enter query: " + acct);
		
		Double v = bank_.get(acct);
		double bal = 0.0;
		if (v != null) {
			bal = v.doubleValue();
		}
		return bal;
	}

	@Override
	public double deposit(String acct, double amt) {
		System.out.println("****enter deposit: " + acct);
		
		Double v = bank_.get(acct);
		double bal = 0.0;
		if (v != null) {
			bal = v.doubleValue();
		}
		bal += amt;
		bank_.put(acct, bal);
		
		return bal;
	}

	@Override
	@TransactionAttribute (TransactionAttributeType.MANDATORY)
	public double draw(String acct, double amt) {
		System.out.println("****enter draw: " + acct);
		
		Double v = bank_.get(acct);
		double bal = 0.0;
		if (v != null) {
			bal = v.doubleValue();
		}
		bal -= amt;
		bank_.put(acct, bal);
		return bal;
	}
	
	@Override
	public String myInvoke() {
		return "success";
	}
}
