package net.shuixin;

import java.util.Properties;

import javax.ejb.Remote;
import javax.ejb.Stateless;
import javax.naming.Context;
import javax.naming.InitialContext;

import com.vitria.bw.NetBank;

@Stateless
@Remote (Bridge.class)
public class BridgeBean implements Bridge {

	@Override
	public void sayHello(String msg) {
		System.out.println("---Received: " + msg);
		if (!msg.equals("skip")) {
			invokeEjb3(msg.indexOf("iiop") >= 0);	
		}
	}

	public void invokeEjb3(boolean iiop) {
		try {
			
			Properties props = new Properties();
			if (iiop) {
				String url = "corbaloc::localhost:3528/JBoss/Naming/root";
				url = "corbaloc::localhost:3528/NameService";
	            String fac = "com.sun.jndi.cosnaming.CNCtxFactory";

	            props.setProperty(Context.INITIAL_CONTEXT_FACTORY, fac);
	            props.setProperty(Context.URL_PKG_PREFIXES, 
	            		"org.jboss.naming.client:org.jnp.interfaces");
	            props.setProperty(Context.PROVIDER_URL, url);
	            
	            props.put(Context.OBJECT_FACTORIES, 
	            		"org.jboss.tm.iiop.client.IIOPClientUserTransactionObjectFactory");
	            props.put("java.naming.corba.orb", 
	            		org.jboss.iiop.naming.ORBInitialContextFactory.getORB());
			} else {
				props.setProperty(Context.INITIAL_CONTEXT_FACTORY,
						"org.jnp.interfaces.NamingContextFactory");
				props.setProperty(Context.PROVIDER_URL, "localhost:1099");
				props.setProperty(Context.URL_PKG_PREFIXES, "org.jboss.naming");	
			}
			
			Context ctx = new InitialContext(props);
			
			NetBank bank = (NetBank) ctx.lookup("jndiNetBankBean");
			
			double bal = bank.deposit("zsx", 100);
			System.out.println("----Balance: " + bal);
			bal = bank.draw("zsx", 30);
			System.out.println("****Balance: " + bal);
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}
}
